searchNodes=[{"doc":"Parameter is a library for dealing with complex datatypes by solving the following problems: Schema creation and validation Input data validation Deserialization Serialization Examples Create a schema defmodule UserParam do use Parameter.Schema alias Parameter.Validators param do field :first_name , :string , key : &quot;firstName&quot; , required : true field :last_name , :string , key : &quot;lastName&quot; field :email , :string , validator : &amp; Validators . email / 1 has_one :address , AddressParam do field :city , :string , required : true field :street , :string field :number , :integer end end end Load (deserialize) the schema against external parameters: params = %{ &quot;firstName&quot; =&gt; &quot;John&quot; , &quot;lastName&quot; =&gt; &quot;Doe&quot; , &quot;email&quot; =&gt; &quot;john@email.com&quot; , &quot;address&quot; =&gt; %{ &quot;city&quot; =&gt; &quot;New York&quot; , &quot;street&quot; =&gt; &quot;York&quot; } } Parameter . load ( UserParam , params ) { :ok , %{ first_name : &quot;John&quot; , last_name : &quot;Doe&quot; , email : &quot;john@email.com&quot; , address : %{ city : &quot;New York&quot; , street : &quot;York&quot; } } } or Dump (serialize) a populated schema to params: schema = %{ first_name : &quot;John&quot; , last_name : &quot;Doe&quot; , email : &quot;john@email.com&quot; , address : %{ city : &quot;New York&quot; , street : &quot;York&quot; } } Parameter . dump ( UserParam , params ) { :ok , %{ &quot;firstName&quot; =&gt; &quot;John&quot; , &quot;lastName&quot; =&gt; &quot;Doe&quot; , &quot;email&quot; =&gt; &quot;john@email.com&quot; , &quot;address&quot; =&gt; %{ &quot;city&quot; =&gt; &quot;New York&quot; , &quot;street&quot; =&gt; &quot;York&quot; } } } For more schema options checkout Parameter.Schema","ref":"Parameter.html","title":"Parameter","type":"module"},{"doc":"Dump the loaded parameters. Options :exclude - Accepts a list of fields to be excluded when dumping the loaded parameter. This option is useful if you have fields in your schema are only for loading. :many - When true will parse the input data as list, when false (default) it parses as map Examples defmodule UserParam do use Parameter.Schema param do field :first_name , :string , key : &quot;firstName&quot; , required : true field :last_name , :string , key : &quot;lastName&quot; has_one :address , Address do field :city , :string , required : true field :street , :string field :number , :integer end end end loaded_params = %{ first_name : &quot;John&quot; , last_name : &quot;Doe&quot; , address : %{ city : &quot;New York&quot; , street : &quot;broadway&quot; } } Parameter . dump ( UserParam , params ) { :ok , %{ &quot;address&quot; =&gt; %{ &quot;city&quot; =&gt; &quot;New York&quot; , &quot;street&quot; =&gt; &quot;broadway&quot; } , &quot;firstName&quot; =&gt; &quot;John&quot; , &quot;lastName&quot; =&gt; &quot;Doe&quot; } } # excluding fields Parameter . dump ( UserParam , params , exclude : [ :first_name , { :address , [ :city ] } ] ) { :ok , %{ &quot;address&quot; =&gt; %{ &quot;street&quot; =&gt; &quot;broadway&quot; } , &quot;lastName&quot; =&gt; &quot;Doe&quot; } }","ref":"Parameter.html#dump/3","title":"Parameter.dump/3","type":"function"},{"doc":"Loads parameters into the given schema. Options :struct - If set to true loads the schema into a structure. If false (default) loads with plain maps. :unknown - Defines the behaviour when unknown fields are presented on the parameters. The options are :ignore (default) or :error . :exclude - Accepts a list of fields to be excluded when loading the parameters. This option is useful if you have fields in your schema are only for dump. The field will not be checked for any validation if it's on the exclude list. :many - When true will parse the input data as list, when false (default) it parses as map Examples defmodule UserParam do use Parameter.Schema param do field :first_name , :string , key : &quot;firstName&quot; , required : true field :last_name , :string , key : &quot;lastName&quot; has_one :address , Address do field :city , :string , required : true field :street , :string field :number , :integer end end end params = %{ &quot;address&quot; =&gt; %{ &quot;city&quot; =&gt; &quot;New York&quot; , &quot;street&quot; =&gt; &quot;broadway&quot; } , &quot;firstName&quot; =&gt; &quot;John&quot; , &quot;lastName&quot; =&gt; &quot;Doe&quot; } Parameter . load ( UserParam , params ) { :ok , %{ first_name : &quot;John&quot; , last_name : &quot;Doe&quot; , address : %{ city : &quot;New York&quot; , street : &quot;broadway&quot; } } } # Using struct options Parameter . load ( UserParam , params , struct : true ) { :ok , % UserParam { first_name : &quot;John&quot; , last_name : &quot;Doe&quot; , address : % AddressParam { city : &quot;New York&quot; , street : &quot;broadway&quot; } } } # Using many: true for lists Parameter . load ( UserParam , [ params , params ] , many : true ) { :ok , [ %{ address : %{ city : &quot;New York&quot; , street : &quot;broadway&quot; } , first_name : &quot;John&quot; , last_name : &quot;Doe&quot; } , %{ address : %{ city : &quot;New York&quot; , street : &quot;broadway&quot; } , first_name : &quot;John&quot; , last_name : &quot;Doe&quot; } ] } # Excluding fields Parameter . load ( UserParam , params , exclude : [ :first_name , { :address , [ :city ] } ] ) { :ok , %{ last_name : &quot;Doe&quot; , address : %{ street : &quot;broadway&quot; } } } # Unknown fields should return errors params = %{ &quot;user_token&quot; =&gt; &quot;3hgj81312312&quot; } Parameter . load ( UserParam , params , unknown : :error ) { :error , %{ &quot;user_token&quot; =&gt; &quot;unknown field&quot; } } # Invalid data should return validation errors: params = %{ &quot;address&quot; =&gt; %{ &quot;city&quot; =&gt; &quot;New York&quot; , &quot;number&quot; =&gt; &quot;123AB&quot; } , &quot;lastName&quot; =&gt; &quot;Doe&quot; } Parameter . load ( UserParam , params ) { :error , %{ first_name : &quot;is required&quot; , address : %{ number : &quot;invalid integer type&quot; } , } } Parameter . load ( UserParam , [ params , params ] , many : true ) { :error , %{ 0 =&gt; %{ address : %{ number : &quot;invalid integer type&quot; } , first_name : &quot;is required&quot; } , 1 =&gt; %{ address : %{ number : &quot;invalid integer type&quot; } , first_name : &quot;is required&quot; } } }","ref":"Parameter.html#load/3","title":"Parameter.load/3","type":"function"},{"doc":"Validate parameters. This function is meant to be used when the data is loaded or created internally. validate/3 will validate field types, required fields and Parameter.Validators functions. Options :exclude - Accepts a list of fields to be excluded when validating the parameters. :many - When true will parse the input data as list, when false (default) it parses as map Examples defmodule UserParam do use Parameter.Schema param do field :first_name , :string , key : &quot;firstName&quot; , required : true field :last_name , :string , key : &quot;lastName&quot; has_one :address , Address do field :city , :string , required : true field :street , :string field :number , :integer end end end params = %{ first_name : &quot;John&quot; , last_name : &quot;Doe&quot; , address : %{ city : &quot;New York&quot; , street : &quot;broadway&quot; } } Parameter . validate ( UserParam , params ) :ok # Invalid data params = %{ last_name : 12 , address : %{ city : &quot;New York&quot; , street : &quot;broadway&quot; , number : &quot;A&quot; } } Parameter . validate ( UserParam , params ) { :error , %{ address : %{ number : &quot;invalid integer type&quot; } , first_name : &quot;is required&quot; , last_name : &quot;invalid string type&quot; } }","ref":"Parameter.html#validate/3","title":"Parameter.validate/3","type":"function"},{"doc":"The field inside a Parameter Schema have the following structure: field :name , :type , opts :name - Atom key that defines the field name :type - Type from Parameter.Types . For custom types check the Parameter.Parametrizable behaviour. :opts - Keyword with field options. Options :key - This is the key from the params that will be converted to the field schema. Examples: If an input field use camelCase for mapping first_name , this option should be set as &quot;firstName&quot;. If an input field use the same case for the field definition, this key can be ignored. :default - Default value of the field when no value is given. :load_default - Default value of the field when no value is given when loading with Parameter.load/3 function. This option should not be used at the same time as default option. :dump_default - Default value of the field when no value is given when loading with Parameter.dump/3 function. This option should not be used at the same time as default option. :required - Defines if the field needs to be present when parsing the input. Parameter.load/3 will return an error if the value is missing from the input data. :validator - Validation function that will validate the field after loading. :virtual - If true the field will be ignored on Parameter.load/3 and Parameter.dump/3 functions. NOTE: Validation only occurs on Parameter.load/3 . By desgin, data passed into Parameter.dump/3 are considered valid. Example As an example having an email field that is required and needs email validation could be implemented this way: field :email , :string , required : true , validator : &amp; Parameter.Validators . email / 1","ref":"Parameter.Field.html","title":"Parameter.Field","type":"module"},{"doc":"","ref":"Parameter.Field.html#t:t/0","title":"Parameter.Field.t/0","type":"type"},{"doc":"The first step for building a schema for your data is to create a schema definition to model the external data. This can be achieved by using the Parameter.Schema macro. The example below mimics an User model that have one main_address and a list of phones . defmodule User do use Parameter.Schema param do field :first_name , :string , key : &quot;firstName&quot; , required : true field :last_name , :string , key : &quot;lastName&quot; , required : true , default : &quot;&quot; has_one :main_address , Address , key : &quot;mainAddress&quot; , required : true has_many :phones , Phone end end defmodule Address do use Parameter.Schema param do field :city , :string , required : true field :street , :string field :number , :integer end end defmodule Phone do use Parameter.Schema param do field :country , :string field :number , :integer end end Parameter offers other ways for creating a schema such as nesting the has_one and has_many fields. This require module name as the second parameter using do at the end: defmodule User do use Parameter.Schema param do field :first_name , :string , key : &quot;firstName&quot; , required : true field :last_name , :string , key : &quot;lastName&quot; , required : true , default : &quot;&quot; has_one :main_address , Address , key : &quot;mainAddress&quot; , required : true do field :city , :string , required : true field :street , :string field :number , :integer end has_many :phones , Phone do field :country , :string field :number , :integer end end end Another possibility is avoiding creating files for a schema at all. This can be done by importing Parameter.Schema and using the param/2 macro. This is useful for adding params in Phoenix controllers. For example: defmodule MyProjectWeb.UserController do use MyProjectWeb , :controller import Parameter.Schema alias MyProject.Users param UserParams do field :first_name , :string , required : true field :last_name , :string , required : true end def create ( conn , params ) do with { :ok , user_params } &lt;- Parameter . load ( __MODULE__ . UserParams , params ) , { :ok , user } &lt;- Users . create_user ( user_params ) do render ( conn , &quot;user.json&quot; , %{ user : user } ) end end end It's recommended to use this approach when the schema will only be used in a single module.","ref":"Parameter.Schema.html","title":"Parameter.Schema","type":"module"},{"doc":"Parameter supports different types to be used in the field inside a schema. The available types are: string atom any integer float boolean map array date time datetime naive_datetime decimal * enum ** * For decimal type add the decimal library into your project. ** Check the Parameter.Enum for more information on how to use enums. For implementing custom types check the Parameter.Parametrizable module. Implementing this behavour in a module makes eligible to be a field in the schema definition.","ref":"Parameter.Types.html","title":"Parameter.Types","type":"module"},{"doc":"","ref":"Parameter.Types.html#base_types/0","title":"Parameter.Types.base_types/0","type":"function"},{"doc":"","ref":"Parameter.Types.html#composite_types/0","title":"Parameter.Types.composite_types/0","type":"function"},{"doc":"","ref":"Parameter.Types.html#dump/2","title":"Parameter.Types.dump/2","type":"function"},{"doc":"","ref":"Parameter.Types.html#load/2","title":"Parameter.Types.load/2","type":"function"},{"doc":"","ref":"Parameter.Types.html#validate/2","title":"Parameter.Types.validate/2","type":"function"},{"doc":"","ref":"Parameter.Types.html#validate!/2","title":"Parameter.Types.validate!/2","type":"function"},{"doc":"","ref":"Parameter.Types.html#t:base_types/0","title":"Parameter.Types.base_types/0","type":"type"},{"doc":"","ref":"Parameter.Types.html#t:composite_types/0","title":"Parameter.Types.composite_types/0","type":"type"},{"doc":"","ref":"Parameter.Types.html#t:t/0","title":"Parameter.Types.t/0","type":"type"},{"doc":"Common validators to use within fields of the Parameter.Schema Examples param User do field :email , :string , validator : &amp; Validators . email ( &amp;1 ) end iex&gt; Parameter . load ( User , %{ &quot;email&quot; =&gt; &quot;not an email&quot; } ) { :error , %{ email : &quot;is invalid&quot; } }","ref":"Parameter.Validators.html","title":"Parameter.Validators","type":"module"},{"doc":"Validates email address param User do field :email , :string , validator : &amp; Validators . email ( &amp;1 ) end iex&gt; Parameter . load ( User , %{ &quot;email&quot; =&gt; &quot;not an email&quot; } ) { :error , %{ email : &quot;is invalid&quot; } } iex&gt; Parameter . load ( User , %{ &quot;email&quot; =&gt; &quot;john@gmail.com&quot; } ) { :ok , %{ email : &quot;john@gmail.com&quot; } }","ref":"Parameter.Validators.html#email/1","title":"Parameter.Validators.email/1","type":"function"},{"doc":"Validates if value is equal to another param User do field :permission , :string , validator : { &amp; Validators . equal / 2 , to : &quot;admin&quot; } end iex&gt; Parameter . load ( User , %{ &quot;permission&quot; =&gt; &quot;super_admin&quot; } ) { :error , %{ permission : &quot;is invalid&quot; } } iex&gt; Parameter . load ( User , %{ &quot;permission&quot; =&gt; &quot;admin&quot; } ) { :ok , %{ permission : &quot;admin&quot; } }","ref":"Parameter.Validators.html#equal/2","title":"Parameter.Validators.equal/2","type":"function"},{"doc":"Validates if a value is between a min and max param User do field :age , :integer , validator : { &amp; Validators . length / 2 , min : 18 , max : 50 } end iex&gt; Parameter . load ( User , %{ &quot;age&quot; =&gt; 12 } ) { :error , %{ age : &quot;is invalid&quot; } } iex&gt; Parameter . load ( User , %{ &quot;age&quot; =&gt; 30 } ) { :ok , %{ age : 30 } }","ref":"Parameter.Validators.html#length/2","title":"Parameter.Validators.length/2","type":"function"},{"doc":"Validates if a value is not a member param User do field :permission , :atom , validator : { &amp; Validators . none_of / 2 , options : [ :admin , :super_admin ] } end iex&gt; Parameter . load ( User , %{ &quot;permission&quot; =&gt; &quot;super_admin&quot; } ) { :error , %{ permission : &quot;is invalid&quot; } } iex&gt; Parameter . load ( User , %{ &quot;permission&quot; =&gt; &quot;normal_user&quot; } ) { :ok , %{ permission : :normal_user } }","ref":"Parameter.Validators.html#none_of/2","title":"Parameter.Validators.none_of/2","type":"function"},{"doc":"Validates if a value is a member of the list param User do field :permission , :atom , validator : { &amp; Validators . one_of / 2 , options : [ :admin , :super_admin ] } end iex&gt; Parameter . load ( User , %{ &quot;permission&quot; =&gt; &quot;normal_user&quot; } ) { :error , %{ permission : &quot;is invalid&quot; } } iex&gt; Parameter . load ( User , %{ &quot;permission&quot; =&gt; &quot;super_admin&quot; } ) { :ok , %{ permission : :super_admin } }","ref":"Parameter.Validators.html#one_of/2","title":"Parameter.Validators.one_of/2","type":"function"},{"doc":"Validates if a value matches a regex expression param User do field :code , :string , validator : { &amp; Validators . regex / 2 , regex : ~r/code/ } end iex&gt; Parameter . load ( User , %{ &quot;code&quot; =&gt; &quot;12345&quot; } ) { :error , %{ code : &quot;is invalid&quot; } } iex&gt; Parameter . load ( User , %{ &quot;code&quot; =&gt; &quot;code:12345&quot; } ) { :ok , %{ code : &quot;code:12345&quot; } }","ref":"Parameter.Validators.html#regex/2","title":"Parameter.Validators.regex/2","type":"function"},{"doc":"","ref":"Parameter.Validators.html#t:resp/0","title":"Parameter.Validators.resp/0","type":"type"},{"doc":"Enum type represents a group of constants that have a value with an associated key. Examples defmodule MyApp.UserParam do use Parameter.Schema enum Status do value :user_online , key : &quot;userOnline&quot; value :user_offline , key : &quot;userOffline&quot; end param do field :first_name , :string , key : &quot;firstName&quot; field :status , MyApp.UserParam.Status end end The Status enum should automatically translate the userOnline and userOffline values when loading to the respective atom values. Parameter . load ( MyApp.UserParam , %{ &quot;firstName&quot; =&gt; &quot;John&quot; , &quot;status&quot; =&gt; &quot;userOnline&quot; } ) { :ok , %{ first_name : &quot;John&quot; , status : :user_online } } Parameter . dump ( MyApp.UserParam , %{ first_name : &quot;John&quot; , status : :user_online } ) { :ok , %{ &quot;firstName&quot; =&gt; &quot;John&quot; , &quot;status&quot; =&gt; &quot;userOnline&quot; } } Enum also supports a shorter version if the key and value are already the same: defmodule MyApp.UserParam do ... enum Status , values : [ :user_online , :user_offline ] ... end Parameter . load ( MyApp.UserParam , %{ &quot;firstName&quot; =&gt; &quot;John&quot; , &quot;status&quot; =&gt; &quot;user_online&quot; } ) { :ok , %{ first_name : &quot;John&quot; , status : :user_online } } Using numbers is also allowed in enums: enum Status do value :active , key : 1 value :pending_request , key : 2 end Parameter . load ( MyApp.UserParam , %{ &quot;status&quot; =&gt; 1 } ) { :ok , %{ status : :active } } It's also possible to create enums in different modules by using the enum/1 macro: defmodule MyApp.Status do import Parameter.Enum enum do value :user_online , key : &quot;userOnline&quot; value :user_offline , key : &quot;userOffline&quot; end end defmodule MyApp.UserParam do use Parameter.Schema alias MyApp.Status param do field :first_name , :string , key : &quot;firstName&quot; field :status , Status end end And the short version: enum values : [ :user_online , :user_offline ]","ref":"Parameter.Enum.html","title":"Parameter.Enum","type":"module"},{"doc":"Custom types for fields can be done by implementing the Parameter.Parametrizable behaviour. This is useful when the basic types provided by Parameter.Types are not enough for loading, validating and dumping data. Examples To create a parameterized type, create a module as shown below: defmodule MyApp.CustomType do use Parameter.Parametrizable @impl true def load ( value ) do { :ok , value } end @impl true def validate ( _value ) do :ok end @impl true def dump ( value ) do { :ok , value } end end Then use the new custom type on a param schema: param MyApp.CustomParam do field :custom_field , MyApp.CustomType , key : &quot;customField&quot; end In general is not necessary to implement dump function since using the macro use Parameter.Parametrizable will already use the validate function to dump the value as a default implementation.","ref":"Parameter.Parametrizable.html","title":"Parameter.Parametrizable","type":"behaviour"},{"doc":"","ref":"Parameter.Parametrizable.html#c:dump/1","title":"Parameter.Parametrizable.dump/1","type":"callback"},{"doc":"","ref":"Parameter.Parametrizable.html#c:load/1","title":"Parameter.Parametrizable.load/1","type":"callback"},{"doc":"","ref":"Parameter.Parametrizable.html#c:validate/1","title":"Parameter.Parametrizable.validate/1","type":"callback"},{"doc":"Any parameter type. It will accept any input value without validations. The same value loaded will be the same dumped.","ref":"Parameter.Types.Any.html","title":"Parameter.Types.Any","type":"module"},{"doc":"Any type will just return the same type value that is passed to dump function Examples iex&gt; Parameter.Types.Any . load ( :any_atom ) { :ok , :any_atom } iex&gt; Parameter.Types.Any . load ( &quot;some string&quot; ) { :ok , &quot;some string&quot; } iex&gt; Parameter.Types.Any . load ( nil ) { :ok , nil }","ref":"Parameter.Types.Any.html#dump/1","title":"Parameter.Types.Any.dump/1","type":"function"},{"doc":"Any type will just return the same type value that is passed to load function Examples iex&gt; Parameter.Types.Any . load ( :any_atom ) { :ok , :any_atom } iex&gt; Parameter.Types.Any . load ( &quot;some string&quot; ) { :ok , &quot;some string&quot; } iex&gt; Parameter.Types.Any . load ( nil ) { :ok , nil }","ref":"Parameter.Types.Any.html#load/1","title":"Parameter.Types.Any.load/1","type":"function"},{"doc":"Always return :ok , any value is valid","ref":"Parameter.Types.Any.html#validate/1","title":"Parameter.Types.Any.validate/1","type":"function"},{"doc":"Atom parameter type","ref":"Parameter.Types.Atom.html","title":"Parameter.Types.Atom","type":"module"},{"doc":"loads atom type Examples iex&gt; Parameter.Types.Atom . load ( :atom ) { :ok , :atom } iex&gt; Parameter.Types.Atom . load ( &quot;atom&quot; ) { :ok , :atom } iex&gt; Parameter.Types.Atom . load ( nil ) { :error , &quot;invalid atom type&quot; } iex&gt; Parameter.Types.Atom . load ( 123 ) { :error , &quot;invalid atom type&quot; }","ref":"Parameter.Types.Atom.html#load/1","title":"Parameter.Types.Atom.load/1","type":"function"},{"doc":"validate atom type Examples iex&gt; Parameter.Types.Atom . validate ( :atom ) :ok iex&gt; Parameter.Types.Atom . validate ( &quot;atom&quot; ) { :error , &quot;invalid atom type&quot; } iex&gt; Parameter.Types.Atom . validate ( nil ) { :error , &quot;invalid atom type&quot; } iex&gt; Parameter.Types.Atom . validate ( 123 ) { :error , &quot;invalid atom type&quot; }","ref":"Parameter.Types.Atom.html#validate/1","title":"Parameter.Types.Atom.validate/1","type":"function"},{"doc":"Boolean parameter type","ref":"Parameter.Types.Boolean.html","title":"Parameter.Types.Boolean","type":"module"},{"doc":"loads boolean type Examples iex&gt; Parameter.Types.Boolean . load ( &quot;true&quot; ) { :ok , true } iex&gt; Parameter.Types.Boolean . load ( &quot;false&quot; ) { :ok , false } iex&gt; Parameter.Types.Boolean . load ( 1 ) { :ok , true } iex&gt; Parameter.Types.Boolean . load ( 0 ) { :ok , false } iex&gt; Parameter.Types.Boolean . load ( &quot;not boolean&quot; ) { :error , &quot;invalid boolean type&quot; }","ref":"Parameter.Types.Boolean.html#load/1","title":"Parameter.Types.Boolean.load/1","type":"function"},{"doc":"validate boolean type Examples iex&gt; Parameter.Types.Boolean . validate ( true ) :ok iex&gt; Parameter.Types.Boolean . validate ( false ) :ok iex&gt; Parameter.Types.Boolean . validate ( &quot;true&quot; ) { :error , &quot;invalid boolean type&quot; } iex&gt; Parameter.Types.Boolean . validate ( nil ) { :error , &quot;invalid boolean type&quot; } iex&gt; Parameter.Types.Boolean . validate ( 123 ) { :error , &quot;invalid boolean type&quot; }","ref":"Parameter.Types.Boolean.html#validate/1","title":"Parameter.Types.Boolean.validate/1","type":"function"},{"doc":"Date parameter type","ref":"Parameter.Types.Date.html","title":"Parameter.Types.Date","type":"module"},{"doc":"loads Date type Examples iex&gt; Parameter.Types.Date . load ( % Date { year : 1990 , month : 5 , day : 1 } ) { :ok , ~D[1990-05-01] } iex&gt; Parameter.Types.Date . load ( { 2020 , 10 , 5 } ) { :ok , ~D[2020-10-05] } iex&gt; Parameter.Types.Date . load ( &quot;2015-01-23&quot; ) { :ok , ~D[2015-01-23] } iex&gt; Parameter.Types.Date . load ( &quot;2015-25-23&quot; ) { :error , &quot;invalid date type&quot; }","ref":"Parameter.Types.Date.html#load/1","title":"Parameter.Types.Date.load/1","type":"function"},{"doc":"validate date type Examples iex&gt; Parameter.Types.Date . validate ( % Date { year : 1990 , month : 5 , day : 1 } ) :ok iex&gt; Parameter.Types.Date . validate ( ~D[1990-05-01] ) :ok iex&gt; Parameter.Types.Date . validate ( &quot;2015-01-23&quot; ) { :error , &quot;invalid date type&quot; }","ref":"Parameter.Types.Date.html#validate/1","title":"Parameter.Types.Date.validate/1","type":"function"},{"doc":"DateTime parameter type","ref":"Parameter.Types.DateTime.html","title":"Parameter.Types.DateTime","type":"module"},{"doc":"Decimal parameter type. Include the Decimal library on your application to use this type: def deps do [ { :parameter , &quot;~&gt; ...&quot; } , { :decimal , &quot;~&gt; 2.0&quot; } ] end","ref":"Parameter.Types.Decimal.html","title":"Parameter.Types.Decimal","type":"module"},{"doc":"Float parameter type","ref":"Parameter.Types.Float.html","title":"Parameter.Types.Float","type":"module"},{"doc":"Integer parameter type","ref":"Parameter.Types.Integer.html","title":"Parameter.Types.Integer","type":"module"},{"doc":"List parameter type","ref":"Parameter.Types.List.html","title":"Parameter.Types.List","type":"module"},{"doc":"Map parameter type","ref":"Parameter.Types.Map.html","title":"Parameter.Types.Map","type":"module"},{"doc":"NaiveDateTime parameter type","ref":"Parameter.Types.NaiveDateTime.html","title":"Parameter.Types.NaiveDateTime","type":"module"},{"doc":"String parameter type","ref":"Parameter.Types.String.html","title":"Parameter.Types.String","type":"module"},{"doc":"Time parameter type","ref":"Parameter.Types.Time.html","title":"Parameter.Types.Time","type":"module"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Enhancements [Parameter] New validate/3 function. Bug fixes [Parameter] dump/3 function to load the value to be dumped.","ref":"changelog.html#v0-7-x-2022-11-07","title":"Changelog - v0.7.x (2022-11-07)","type":"extras"},{"doc":"Enhancements [Parameter] API changes to support new parameter_ecto library [Parameter] Support for many flag on load/3 and dump/3 options [Parameter] Errors when parsing list return as map with %{index =&gt; reason} now instead of {:\#{index}, reason} to avoid atom creation [Parameter.Field] Support for load_default and dump_default options [Parameter.Enum] Deprecated as in favour of key Bug fixes [Parameter.Field] Return default value when calling Parameter.dump/3 with empty value.","ref":"changelog.html#v0-6-x-2022-11-06","title":"Changelog - v0.6.x (2022-11-06)","type":"extras"},{"doc":"Enhancements [Parameter] Support for exclude option for load/3 and dump/3 . [Parameter.Types] Support for any type [Parameter.Schema] Support for virtual fields","ref":"changelog.html#v0-5-x-2022-10-26","title":"Changelog - v0.5.x (2022-10-26)","type":"extras"}]